`Plot.credible.intervals`<-
function(object,base.labels,mix.labels,Plot=TRUE)
{
      temp<-object$summary
      parms.rows<-grep("P",object$root.short)
      ci.posn<-match(c("2.5%","50%","97.5%"),dimnames(object$summary)[[2]])
      ci.rows<-grep("P[[:digit:]]\\[",rownames(object$summary))
      no.mix<-length(parms.rows)
      no.base<-length(grep(object$root.short[parms.rows[1]],rownames(object$summary)))
       out<-as.data.frame(matrix(NA,no.base*no.mix,5))
          names(out)<-c("2.5%","50%","97.5%","Mix","Base")
          out[,1:3]<-object$summary[ci.rows,ci.posn]
           out$Base<-rep(base.labels,no.base)
           out$Mix<-as.vector(matrix(mix.labels,no.base,no.mix,byrow=TRUE))
      if(Plot){
      old.mfrow<-par()$mfrow
      old.mar<-par()$mar
      old.omi<-par()$omi
      par(mfrow=c(round(no.mix/2),2), mar =c(2,2,0,0), omi =c(0.75, 0.50, 0.1, 0.1))
        for(i in 1:no.mix){
        temp.out<-out[out$Mix==mix.labels[i],]
        plot(unlist(temp.out[1,1:3]),rep(1,3),xlim=c(0,1),ylim=c(0,no.base+1),type="b",yaxt="n")
        text(0.1,no.base+1,mix.labels[i])
        axis(2,at=1:no.base,labels=base.labels,cex=0.7)
        for(j in 2:no.base){
        lines(unlist(temp.out[j,1:3]),rep(j,3),type="b",lty=1+j,pch=j)
        }
      }
      mtext("Group membership probability",1,2.5,outer=TRUE)
      mtext("Base groups",2,1.5,outer=TRUE)
      par(mfrow=old.mfrow,mar=old.mar,omi=old.omi)
      }
      else return(out)
  }