`combined.model` <-
function(combined.data, loci, mixparameters=NULL)
{

    n.mix <- grep("N.mix", names(combined.data))
    G <- length(n.mix)
    L <- length(loci)
    GG <- combined.data$G

#Default Parameters
    lnmix<-length(n.mix)
    params <- vector("character", length = (lnmix*2)+2)
    for(i in 1:lnmix){
        params[i] <- paste("T", i, sep="")
        params[i+lnmix] <- paste("P", i, sep="")
	}
	params[lnmix*2+1] <- paste("lambda")
	params[lnmix*2+2] <- paste("tau")


#Create mixmodel.txt text file in local directory	
    x.out <- paste("model;", "\n", "{")
    cat(x.out, "\n", file="mixmodel.txt", append=FALSE)

#Mixture sample
    for(i in 1:G){
#combined      
          x1 <- paste("for( i in 1 : ", names(combined.data[n.mix[i]]), ")  {", sep="")
          x2 <- paste("T", i, "[i] ~ dcat(P", i, "[])", sep="")
          x.out <- paste(x1,'\n',x2)
          
          cat(x.out, "\n", file="mixmodel.txt", append=TRUE)

#otolith
          xo2 <- paste("y.mix", i, "[i,1:V] ~ dmnorm(mu.", i, "[i,1:V], tau[,])", sep="")
          xo3 <- paste("for(n in 1:V){")
          xo4 <- paste("mu.", i, "[i,n] <- lambda[T", i, "[i],n]", sep="")
          xo5 <- paste("}")			
          x.out <- paste(xo2,xo3,xo4,xo5, sep="\n")
          cat(x.out, "\n", file="mixmodel.txt", append=TRUE)

#genetic
       for(m in 1:L) {
          x3 <- paste(paste("pi.ind", i, loci[m], sep = "."), "[i]<-", sep="")
          x4 <- paste("pi.", loci[m], "[T", i, "[i],", paste("mix.posn", i, loci[m], sep="."), "[1,i]]", sep="")
          x5 <- paste("*pi.", loci[m], "[T", i, "[i],", paste("mix.posn", i, loci[m], sep="."), "[2,i]]", sep="")
          x6 <- paste(paste("*HWE.mult", i, loci[m], sep="."), "[i]", sep="")
          x.out <- paste(x3,x4,x5,x6)

          x7 <- paste(paste("ind", i, loci[m], sep="."), "[i]~dbern(pi.ind.", paste(i, loci[m], sep="."), "[i])", sep="")
          
          cat(x.out, "\n", x7, "\n", file="mixmodel.txt", append=TRUE)

       }

       x.out <- paste("}")
       cat(x.out, "\n", file="mixmodel.txt", append=TRUE)
    }

#Training Sample
#otolith
       xo1 <- paste("for( j in 1 : Ntrain.oto) {", sep="")
       xo2 <- paste("y.base[j,1:V] ~ dmnorm(mu[j,1:V], tau[1:V,1:V])")
       xo3 <- paste("for(n in 1:V){")
       xo4 <- paste("mu[j,n] <- lambda[Train.oto[j],n]")
       xo5 <- paste("}")			
       xo6 <- paste("}")			

       x.out <- paste(xo1, xo2, xo3, xo4, xo5, xo6, sep="\n")
       cat(x.out, "\n", file="mixmodel.txt", append=TRUE)

#genetic
       x.out <- paste("for( j in 1 : G) {", sep="")
       cat(x.out, "\n", file="mixmodel.txt", append=TRUE)

    for(n in 1:L){
       x.out <- paste(paste("base", loci[n], sep="."), "[j, 1:M.", loci[n], "]~dmulti(pi.", loci[n], "[j,],NTrain.gen[j])", sep="")
       cat(x.out, "\n", file="mixmodel.txt", append=TRUE)
    }
       x.out <- paste("}")
       cat(x.out, "\n", file="mixmodel.txt", append=TRUE)

#Priors
#combined
    for(n in 1:G){
      x.out <- paste("P", n, "[1:G] ~ ddirch(alpha[])", sep="")
      cat(x.out, "\n", file="mixmodel.txt", append=TRUE)
    }

#otolith
       xo1 <- paste("tau[1:V,1:V] ~ dwish(R[,],V)")
       xo2 <- paste("sigma[1:V,1:V]<-inverse(tau[ , ])")
       xo3 <- paste("for(k in 1:G){")
       xo4 <- paste("for(kk in 1:V) {")
       xo5 <- paste("lambda[k,kk]~dnorm(0.0,1.0E-6)")
       xo6 <- paste("}")			
       xo7 <- paste("}")			

          x.out <- paste(xo1, xo2, xo3, xo4, xo5, xo6, xo7, sep="\n")
          cat(x.out, "\n", file="mixmodel.txt", append=TRUE)

#genetic
      x.out <- paste("for(g in 1:G) {")
      cat(x.out, "\n", file="mixmodel.txt", append=TRUE)

      for(f in 1:L){

		x1 <- paste("for(kk in 1:M.", loci[f], ") {", sep="")
            x2 <- paste("pi.", loci[f], "[g,kk]<-pi.r.", loci[f], "[g,kk]/sum(pi.r.", loci[f], "[g,])", sep="")
		x3 <-	paste("pi.r.", loci[f], "[g,kk]~dgamma(alpha.", loci[f], "[kk],1.0)I(1.0E-5,)", sep="")
            x4 <- paste(" }")
            x.out <- paste(x1, x2, x3, x4, sep="\n")

            cat(x.out, "\n", file="mixmodel.txt", append=TRUE)

       }

       x.out <- paste("}")
       cat(x.out, "\n", file="mixmodel.txt", append=TRUE)

#Posterior Predictive Diagnostic
#otolith
       x1 <- paste("for( j in 1 : Ntrain.oto) {")
       x2 <- paste("yrep[j,1:V] ~ dmnorm(mu[j,1:V], tau[1:V,1:V])")
       x3 <- ("}")
          x.out <- paste(x1, x2, x3, sep="\n")
          cat(x.out, "\n", file="mixmodel.txt", append=TRUE)

       x.out <- paste("for( i in 1 :V) {")
          cat(x.out, "\n", file="mixmodel.txt", append=TRUE)

       for(m in 1:GG){

         y1 <- paste("NTrain[", m, "]", sep="")

         if(m == 1){
             xx <- paste("1")
             x1 <- paste("yrepmean", m, "[i]<-mean(yrep[", xx, ":", y1, ",i])", sep="")
             yy <- y1
         } else {
             xx <- paste("1+", yy, sep="")
             yy <- paste( yy, "+NTrain[", m, "]", sep="")
             x1 <- paste("yrepmean", m, "[i]<-mean(yrep[(", xx, "):(", yy, "),i])", sep="")
         }
         
          x2 <- paste("otopredcheck", m, "[i]<-step(y.mean", m, "[i]-yrepmean", m, "[i])", sep="")

          x.out <- paste(x1, x2, sep="\n")
          cat(x.out, "\n", file="mixmodel.txt", append=TRUE)		
			
       }
          x.out <- paste("}")
          cat(x.out, "\n", file="mixmodel.txt", append=TRUE)

#genetic
       x.out <- paste("for( j in 1 : G) {", sep="")
       cat(x.out, "\n", file="mixmodel.txt", append=TRUE)

    for(n in 1:L){
       x.out <- paste(paste("rep", loci[n], sep="."), "[j, 1:M.", loci[n], "]~dmulti(pi.", loci[n], "[j,],NTrain.gen[j])", sep="")
       cat(x.out, "\n", file="mixmodel.txt", append=TRUE)
    }
       x.out <- paste("}")
       cat(x.out, "\n", file="mixmodel.txt", append=TRUE)

 #New additions.  S.J. Smith 08/07/2009
 
       x.out <- paste("for( i in 1 : G) {", sep="")
       cat(x.out, "\n", file="mixmodel.txt", append=TRUE)

      for(f in 1:L){
      x1 <- paste("for(j in 1:M.", loci[f], ") {", sep="")
       x1.1<-paste("pi.",loci[f],"[i,j]*NTrain.gen[i]",sep="")
        x2<-paste("Xrep.",loci[f],"[i,j]<-pow(rep.",loci[f],"[i,j] - ",x1.1,",2)/(",x1.1,")",sep="")
         x3<-paste("Xobs.",loci[f],"[i,j]<-pow(base.",loci[f],"[i,j] - ",x1.1,",2)/(",x1.1,")",sep="")
          x4 <- paste("}")
           x5<-paste("genpredcheck",f,"[i]<-step(sum(Xrep.",loci[f],"[i,])-sum(Xobs.",loci[f],"[i,]))",sep="")
            x.out <- paste(x1, x2, x3, x4, x5, sep="\n")
       cat(x.out, "\n", file="mixmodel.txt", append=TRUE)
        }
       x.out <- paste("}")
       cat(x.out, "\n", file="mixmodel.txt", append=TRUE)
       

# End of new additions.  S.J. Smith


#end of model
    x.out <- paste("}")
    cat(x.out, "\n", file="mixmodel.txt", append=TRUE)

#Default Parameters
    if(is.null(mixparameters)){
    return(params)
	}
	
}

