`otolith.model` <-
function(otolith.data, mixparameters=NULL)
{

    n.mix <- grep("N.mix", names(otolith.data))
    G <- otolith.data$G
#    V <- otolith.data$V

#Default Parameters
    lnmix<-length(n.mix)
    params <- vector("character", length = (lnmix*2)+2)
    for(i in 1:lnmix){
        params[i] <- paste("T", i, sep="")
        params[i+lnmix] <- paste("P", i, sep="")
	}
	params[lnmix*2+1] <- paste("lambda")
	params[lnmix*2+2] <- paste("tau")


#Create mixmodel.txt text file in local directory	
    x.out <- paste("model;", "\n", "{")
    cat(x.out, "\n", file="mixmodel.txt", append=FALSE)
	
#Mixture sample
    for(i in 1:length(n.mix)){

          x1 <- paste("for( i in 1 : ", names(otolith.data[n.mix[i]]), ")  {", sep="")
          x6 <- paste("T", i, "[i] ~ dcat(P", i, "[])", sep="")
          x2 <- paste("y.mix", i, "[i,1:V] ~ dmnorm(mu.", i, "[i,1:V], tau[,])", sep="")
          x3 <- paste("for(n in 1:V){")
          x4 <- paste("mu.", i, "[i,n] <- lambda[T", i, "[i],n]", sep="")
          x5 <- paste("}")			
          x7 <- paste("}")			
          x.out <- paste(x1, x6, x2, x3, x4, x5, x7, sep="\n")
          cat(x.out, "\n", file="mixmodel.txt", append=TRUE)
      
    }


#Training Sample

       x1 <- paste("for( j in 1 : Ntrain.oto) {", sep="")
       x2 <- paste("y.base[j,1:V] ~ dmnorm(mu[j,1:V], tau[1:V,1:V])")
       x3 <- paste("for(n in 1:V){")
       x4 <- paste("mu[j,n] <- lambda[Train.oto[j],n]")
       x5 <- paste("}")			
       x6 <- paste("}")			

       x.out <- paste(x1, x2, x3, x4, x5, x6, sep="\n")
       cat(x.out, "\n", file="mixmodel.txt", append=TRUE)


#Priors

    for(n in 1:length(n.mix)){ 
      x.out <- paste("P", n, "[1:G] ~ ddirch(alpha[])", sep="")
      cat(x.out, "\n", file="mixmodel.txt", append=TRUE)
    }


       x1 <- paste("tau[1:V,1:V] ~ dwish(R[,],V)")
       x2 <- paste("sigma[1:V,1:V]<-inverse(tau[ , ])")
       x3 <- paste("for(k in 1:G){")
       x4 <- paste("for(kk in 1:V) {")
       x5 <- paste("lambda[k,kk]~dnorm(0.0,1.0E-6)")
       x6 <- paste("}")			
       x7 <- paste("}")			

          x.out <- paste(x1, x2, x3, x4, x5, x6, x7, sep="\n")
          cat(x.out, "\n", file="mixmodel.txt", append=TRUE)


#Posterior Predictive Diagnostic

       x1 <- paste("for( j in 1 : Ntrain.oto) {")
       x2 <- paste("yrep[j,1:V] ~ dmnorm(mu[j,1:V], tau[1:V,1:V])")
       x3 <- ("}")
          x.out <- paste(x1, x2, x3, sep="\n")
          cat(x.out, "\n", file="mixmodel.txt", append=TRUE)

       x.out <- paste("for( i in 1 :V) {")
          cat(x.out, "\n", file="mixmodel.txt", append=TRUE)

       for(m in 1:G){

         y1 <- paste("NTrain[", m, "]", sep="")

         if(m == 1){
             xx <- paste("1")
             x1 <- paste("yrepmean", m, "[i]<-mean(yrep[", xx, ":", y1, ",i])", sep="")
             yy <- y1
         } else {
             xx <- paste("1+", yy, sep="")
             yy <- paste( yy, "+NTrain[", m, "]", sep="")
             x1 <- paste("yrepmean", m, "[i]<-mean(yrep[(", xx, "):(", yy, "),i])", sep="")
         }
         
          x2 <- paste("otopredcheck", m, "[i]<-step(yrepmean", m, "[i]-y.mean", m, "[i])", sep="")

          x.out <- paste(x1, x2, sep="\n")
          cat(x.out, "\n", file="mixmodel.txt", append=TRUE)		
			
       }
          x.out <- paste("}")
          cat(x.out, "\n", file="mixmodel.txt", append=TRUE)

#end of model
    x.out <- paste("}")
    cat(x.out, "\n", file="mixmodel.txt", append=TRUE)
    
#Default Parameters
    if(is.null(mixparameters)){
    return(params)
	}

}

