\name{Plot.credible.intervals}
\Rdversion{1.1}
\alias{Plot.credible.intervals}

\title{
  Plot 95\% credible intervals
}
\description{
This function extracts the 95\% credible interval for each of the monitored nodes returned by 
\code{\link{mix.fish}}. Output can be a dataframe containing the data to plot or to 
the current plot device.
}
\usage{
Plot.credible.intervals(object, base.labels, mix.labels, Plot = TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{object}{
 a object returned by  \code{\link{mix.fish}}.
}
  \item{base.labels}{
are labels from base groups. See \code{base} in \code{\link{mix.fish}}.
}
  \item{mix.labels}{
are labels from mixture groups. See \code{mix} in \code{\link{mix.fish}}.
}
  \item{Plot}{
is a logical variable indicating whether or not a figure will be plotted.  If Plot=FALSE function
returns a dataframe of data to be plotted.
}
}
\details{
The \code{\link{plot.bugs}} function returns 80\% credible intervals for all monitored nodes in 
the \code{\link{bugs}} object plus a plot for R-hat to evaluate convergence. The function described here simply plots
the median and 95\% credible interval for the group membership nodes.
}
\value{
A plot to the current device if Plot=TRUE (default) or a dataframe of data to be plotted if Plot=FALSE.
}
\references{
%% ~put references to the literature/web site here ~
}
\author{
Stephen Smith \email{Stephen.Smith@dfo-mpo.gc.ca}
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
data(codmix)
 
mymix<-mix.fish(data=codmix,method="otolith",groups="STOCK",
otolith.var=c("BA", "LILN", "MGLNDET2", "MNDET2", "SRDET2"), 
mixparameters=c("P1","P2","P3","P4"),base=codmix[codmix$SEASON=="S96",],
basetows=c("3Pn4RS","3Ps","4T","4Vs"),mix=codmix[codmix$SEASON=="J96",],
mixtows=c("3Pn4RS","3Ps","4Vn","4Vs"),type="random",n.chains=2,n.iter=2000)

Plot.credible.intervals(mymix,base.labels=c("3Pn4RS","3Ps","4T","4Vs"),
mix.labels=c("3Pn4RS","3Ps","4Vn","4Vs"))
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ hplot }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
